                        /* Halton.prc */
/* 
** Given an ID variable, id, this will return k Halton series, of length, l **
*/                                                                                                     
 
proc 1 = _Halton(id,k,length,prime_num);
local N, prim, hm, hm2, hm3, hm4, hm5, hm6, hm7, hm8, hm9, hm10, ai_mat;
	
N       = maxc(id);


/* CREATE STANDARD RANDOM NUMBERS USING HALTON DRAWS */

prim = { 3 5 7 11 13 17 19 23 29 31 37 41 43 47 53 59 61 67 71
                   73 79 83 89 97 101 103 107 109 113 };
/*
if prime_num eq 1;

    load ai_mat;
    if rows(ai_mat) .eq rows(id) .and cols(ai_mat) .eq k*length;
        goto skip_gen;
    endif;	
    
endif;
*/
    
hm      = halton(10+(length*N),prim[prime_num]);
hm      = hm[11:rows(hm)];
hm      = cdfni(hm);
hm      = reshape(hm,N,length);

if k ge 2;

    hm2     = halton(10+(length*N),prim[prime_num+1]);
    hm2     = hm2[11:rows(hm2)];
    hm2     = cdfni(hm2);
    hm2     = reshape(hm2,N,length);
    hm      = hm~hm2;

    if k ge 3;
    
        hm3     = halton(10+(length*N),prim[prime_num+2]);
        hm3     = hm3[11:rows(hm3)];
        hm3     = cdfni(hm3);
        hm3     = reshape(hm3,N,length);
        hm      = hm~hm3;

        if k ge 4;
    
            hm4     = halton(10+(length*N),prim[prime_num+3]);
            hm4     = hm4[11:rows(hm4)];
            hm4     = cdfni(hm4);
            hm4     = reshape(hm4,N,length);
            hm      = hm~hm4;

            if k ge 5;
    
                hm5     = halton(10+(length*N),prim[prime_num+4]);
                hm5     = hm5[11:rows(hm5)];
                hm5     = cdfni(hm5);
                hm5     = reshape(hm5,N,length);
                hm      = hm~hm5;

                if k ge 6;
    
                    hm6     = halton(10+(length*N),prim[prime_num+5]);
                    hm6     = hm6[11:rows(hm6)];
                    hm6     = cdfni(hm6);
                    hm6     = reshape(hm6,N,length);
                    hm      = hm~hm6;

                    if k ge 7;
    
                        hm7     = halton(10+(length*N),prim[prime_num+6]);
                        hm7     = hm7[11:rows(hm7)];
                        hm7     = cdfni(hm7);
                        hm7     = reshape(hm7,N,length);
                        hm      = hm~hm7;

                        if k ge 8;
    
                            hm8     = halton(10+(length*N),prim[prime_num+7]);
                            hm8     = hm8[11:rows(hm8)];
                            hm8     = cdfni(hm8);
                            hm8     = reshape(hm8,N,length);
                            hm      = hm~hm8;

                            if k ge 9;
    
                                hm9     = halton(10+(length*N),prim[prime_num+8]);
                                hm9     = hm9[11:rows(hm9)];
                                hm9     = cdfni(hm9);
                                hm9     = reshape(hm9,N,length);
                                hm      = hm~hm9;
                                
                                if k ge 10;
    
                                    hm10    = halton(10+(length*N),prim[prime_num+9]);
                                    hm10    = hm10[11:rows(hm10)];
                                    hm10    = cdfni(hm10);
                                    hm10    = reshape(hm10,N,length);
                                    hm      = hm~hm10;

                                endif;

                            endif;

                        endif;

                    endif;

                endif;

            endif;

        endif;

    endif;

endif;

ai_mat = hm[id,.];
/*
if prime_num eq 1;
    save ai_mat;
endif;
*/	
		  /* RETURN OUTPUTS */

skip_gen:

retp(ai_mat);
endp;


/*  Proc to create Halton sequences using the pattern described in Train, "Halton Sequences
for Mixed Logit." The integer n is the length of the Halton sequence that is required, and 
s is the prime that is used in creating the sequence. 

Given the length of the sequence n, the integer k is determined such that s^k<n<s^k+1. That is,
a sequence using s1 up to s^k is too short, and a sequence using s1 up to s^(k+1) is too long. 
Using this fact, the proc is divided in two parts to save time and space. 
The first part creates the sequence for s1 up to s^k. The second
part creates only as much as needed of the additional sequence using s^(k+1). */

proc halton(n,s);
local phi,i,j,y,x,k;
k=floor(ln(n+1) ./ ln(s));    @We create n+1 Halton numbers including the initial zero.@
phi={0};
i=1;
do while i .le k;  
  x=phi;
   j=1;
  do while j .lt s;
     y=phi+(j/s^i);
     x=x|y;
     j=j+1;
  endo;
  phi=x;
  i=i+1;
endo;
 
x=phi;
 j=1;
do while j .lt s .and rows(x) .lt (n+1);  
   y=phi+(j/s^i);
   x=x|y;
   j=j+1;
 endo;

phi=x[2:(n+1),1];  @Starting at the second element gets rid of the initial zero.@
retp(phi);
endp;

proc 1 = _IC(logL,N,k);
local BIC, AIC, CAIC, HQIC;	
	
	BIC   = (-2*logL) + (ln(N)*k);  
	AIC   = (-2*logL) + (2*k);  
	CAIC  = (-2*logL) + ((1+ln(N))*k);  
	HQIC  = (-2*logL) + ((2*ln(ln(N)))*k);  

retp(BIC~AIC~CAIC~HQIC);
endp;

