new;
cls;
library cmlmt;
#include cmlmt.sdf;
closeall;
tStart = hsec;  

clear index;
clearg cond_Y_N, M, count, count_sum, d_ij, N, N_panel;

          /* PROGRAM TO IOP and TOP MODELS (for 3 outcomes) */

#include U:\ManW10\Desktop\Mark code 21st June 2022\IOP_TOP_RE_MT.prc; 
#include U:\ManW10\Desktop\Mark code 21st June 2022\Halton.prc;
#include U:\ManW10\Desktop\Mark code 21st June 2022\hitmiss.prc;

			/* LOAD RAW DATA AND NAME VARIABELS */

//exp_bal_data = loadd("F:/karl's files/Expectations/JMCB revision/gauss/exp_bal_data.dta", "cat(expect) + date($pid) + cat(year) + cat(sex) + cat(white) + cat(a_1830) + cat(a_3140) + cat(a_4150) + cat(deg) + cat(alev) + cat(olev) + cat(nkids) + cat(marr) + cat(emp) + cat(semp) + cat(unemp) + cat(ownor) + cat(mort) + cat(rentc) + cat(llab) + cat(lnlab) + cat(lsaved) + cat(lwealth) + cat(hlghq2) + cat(jbsat) + cat(ue_all) + cat(y_up) + cat(y_down) + cat(ex_up) + cat(ex_down) + cat(Mllab) + cat(Mlnlab) + cat(Mlsaved) + cat(Mlwealth) + cat(nc2_opt) + cat(nc2_pes) + cat(nc2_sam) + cat(NC2_opt) + cat(NC2_pes) + cat(NC2_sam) + cat(chivid) + cat(totprob) + cat(ivfa) + cat(ilength) + yr2 + yr3 + yr4 + yr5 + yr6 + yr7 + yr8 + yr9 + yr10 + yr11 + yr12 + yr13 + yr14 + yr15 + yr16 + yr17 + cat(fisitc) + trend + intopt + intpess");
infile = "U:\\ManW10\\Desktop\\Mark code 21st June 2022\\exp_bal_data_V4";

exp_bal_data    = loadd(infile);
headers         = getHeaders(infile);
exp_bal_data    = sampleData(exp_bal_data, rows(exp_bal_data));
exp_bal_data    = sortc(exp_bal_data,"PID" $| "YEAR");

// Declare control structure and fill in with defaults
struct dstatmtControl dctl;
dctl = dstatmtControlCreate();

// delete missing values
dctl.miss = 2;

// Calculate statistics, and place output in 'dout'
call dstatmt(infile, ".", dctl);

y		        = exp_bal_data[.,"EXPECT"];
y		        = y-minc(y);
id              = exp_bal_data[.,"PID"];
id              = id - minc(id) +1;

/* DEFINE CURRENT FINANCIAL POSITION */

SUBJ_CHANGE     = exp_bal_data[.,"FISITC"];
subj_bet        = SUBJ_CHANGE .eq 1;
subj_wrs        = SUBJ_CHANGE .eq 2;

/* DEFINE INCOME AND EXPENDITURE SHOCKS */

incorrect   = (exp_bal_data[.,"NC_ALL"]) .ge 1;  
y_shock     = ((exp_bal_data[.,"Y_UP"] .* incorrect) + (exp_bal_data[.,"Y_DOWN"] .* incorrect)) .ge 1;
ex_shock    = ((exp_bal_data[.,"EX_UP"] .* incorrect) + (exp_bal_data[.,"EX_DOWN"] .* incorrect)) .ge 1;


/* DEFINE VARIABLES IN BLOCKS: VARIABLES IN ALL EQUATIONS */

x_joint         = exp_bal_data[.,"A_1830" "A_3140" "A_4150" "SEX" "DEG" "ALEV" "OLEV"];
x_joint_vars    = "A_1830" $| "A_3140" $| "A_4150" $| "SEX" $| "DEG" $| "ALEV" $| "OLEV";


/* DEFINE VARIABLES IN BLOCKS: VARIABLES IN THE NON-CHANGE PROPENSITIES (X_UP_ONLY AND X_DOWN_ONLY; NOTE X_UP_ONLY = X_DOWN_ONLY */

x_up_only       = ones(rows(exp_bal_data),1)~exp_bal_data[., "NC_ALL" "BIG5A" "BIG5C" "BIG5E" "BIG5N" "BIG5O" "CHIVID" "TOTPROB" "IVFA" "ILENGTH"];            
x_up_only_vars  =  "CONST" $| "NC_ALL" $| "BIG5A" $| "BIG5C" $| "BIG5E" $| "BIG5N" $| "BIG5O"  $| "CHIVID" $| "totprob" $| "ivfa" $| "ilength";


/* DEFINE Z-ONLY VARIABLES */

/*
x_y_only        = exp_bal_data[.,"Y_UP" "y_down" "ex_up" "ex_down"]~
                            exp_bal_data[.,"nkids" "marr" "white" "emp" "semp" "unemp" "ownor" "mort" "rentc"]~ 
                            (exp_bal_data[.,"llab" "lnlab" "lsaved" "lwealth"] ./ 10)~exp_bal_data[.,"jbsat"]~(exp_bal_data[.,"hlghq2" "ue_all" "trend"] ./ 10)~((exp_bal_data[.,"trend"] .^ 2) ./ 100)~
                        exp_bal_data[.,"intopt" "intpess"]~
                        (exp_bal_data[.,"Mllab" "Mlnlab" "Mlsaved" "Mlwealth"] ./ 10);  
                            
x_y_only_vars   = "y_up" $| "y_down" $| "ex_up" $| "ex_down" $|
                        "y_shk_u" $| "y_shk_d" $| "ex_shk_u" $| "ex_shk_d" $| 
                        "nkids" $| "marr" $| "white" $| "emp" $| "semp" $| "unemp" $| "ownor" $| "mort rentc" $| 
                        "llab" $| "lnlab" $| "lsaved" $| "lwealth" $| "jbsat" $| "hlghq2" $| "ue_all" $| 
                        "trend" $| "trend2_10" $| 
                        "opt_0" $| "pess_0" $| 
                        "Mllab" $| "Mlnlab" $| "Mlsaved" $| "Mlwealth";
*/

x_y_only   			= exp_bal_data[.,"Y_UP" "Y_DOWN" "EX_UP" "EX_DOWN"]~
                        exp_bal_data[.,"NKIDS" "MARR" "WHITE" "EMP" "SEMP" "UNEMP" "OWNOR" "MORT" "RENTC"]~ 
                        (exp_bal_data[.,"LLAB" "LNLAB" "LSAVED" "LWEALTH"] ./ 10)~exp_bal_data[.,"JBSAT"]~(exp_bal_data[.,"HLGHQ2" "UE_ALL"] ./ 10)~
                        exp_bal_data[.,"YR2" "YR3" "YR4" "YR5" "YR6" "YR7" "YR8" "YR9" "YR10" "YR11" "YR12" "YR13" "YR14" "YR15" "YR16" "YR17"]~	
                        exp_bal_data[.,"INTOPT" "INTPESS"]~
                        (exp_bal_data[.,"MLLAB" "MLNLAB" "MLSAVED" "MLWEALTH"] ./ 10);  
                            
x_y_only_vars   = "Y_UP" $| "Y_DOWN" $| "EX_UP" $| "EX_DOWN" $|
                        "NKIDS" $| "MARR" $| "WHITE" $| "EMP" $| "SEMP" $| "UNEMP" $| "OWNOR" $| "MORT" $| "RENTC" $| 
                        "LLAB" $| "lnlab" $| "lsaved" $| "lwealth" $| "jbsat" $| "hlghq2" $| "ue_all" $| 
                        "yr2" $| "yr3" $| "yr4" $| "yr5" $| "yr6" $| "yr7" $| "yr8" $| "yr9" $| "yr10" $| "yr11" $| "yr12" $| "yr13" $| "yr14" $| "yr15" $| "yr16" $| "yr17" $|	
                        "opt_0" $| "pess_0" $| 
                        "Mllab" $| "Mlnlab" $| "Mlsaved" $| "Mlwealth";


k_y	= cols(x_y_only);

/* DELETE ANY MISSING VALUES */

x_all   = x_joint~x_y_only~x_up_only;        @ STACK DATA IN ORDER: COMMON, X_Y_ONLY, X_UP_ONLY @

yx_all  = packr(y~id~x_all);
y 	    = yx_all[.,1];
idvec   = yx_all[.,2];
x_all   = yx_all[.,3:cols(yx_all)];

pid     = idvec;

/* THE CONTIGID ID VECTOR MUST BE CONTIGUOUS! AND START AT 1 */

tvec     = 1;
idcontig = 1;
irep = 2;
do while irep le rows(y);
 
	if idvec[irep] eq idvec[irep-1];

	    idcontig = idcontig|idcontig[irep-1];
	    tvec     = tvec|tvec[irep-1]+1;

	else;

	    idcontig = idcontig|(idcontig[irep-1]+1);
        tvec     = tvec|1;

	endif;

    irep = irep + 1;

endo;

idvec = idcontig;

T 		= maxc(tvec);
capJ	= maxc(y) - minc(y) + 1;
kall    = cols(x_all);
N       = rows(y);
N_panel = maxc(idvec);

/* CREATE A COUNT N BY 1 COUNT VARIABLE */

count       = counts(idvec,seqa(1,1,maxc(idvec)));
let count_name = count;
count_sum   = cumsumc(1|count);

if minc(count) eq 0;
	"Error empty id value";stop;
endif;


			/* NAME X'S & Y'S & SAVE */

yvars           = "expect";
x_all_vars      = x_joint_vars $| x_y_only_vars $| x_up_only_vars;
id_name         = "id";
y_x_all_vars    = yvars $| id_name $|x_all_vars;

data            = y~idcontig~x_all;

// Create the GAUSS dataset, 'mydata.dat'
fname = "FE_dat_shock";

// Create dataset with: 3 columns, 8 byte data and 1=numeric columns
fh = datacreate(fname, y_x_all_vars, cols(data), 8, 1);
call writer(fh, data);
call close(fh);


/* DSTATS on estimation ssample */

// Declare control structure and fill in with defaults
struct dstatmtControl ctl;
ctl         = dstatmtControlCreate();
ctl.miss    = 1;
// Declare output structure
struct dstatmtOut dout;
dout        = dstatmt("FE_dat_shock", ".", dctl);
            
            
    /* CONSTRUCT INDICATOR VARIABLES FOR j=J */

d_ij	= {};

for jrep (minc(y),maxc(y),1);
	d_ij = d_ij~(y .eq jrep);
endfor;

phat = meanc(d_ij);

/* NEED AN INDICATOR VARIABLE TO LET PROC KNOW WHAT X'S ARE FOR PROBIT MODEL & WHAT Z'S ARE FOR ORDERED MODEL */

/* specifies x's corresponding to "y_x_all_vars" above - ignoring y and same for z's in ordered model */

/*
x_y_vec              	= zeros(1,cols(x_all));                                 /* ordered probit model */
x_y_vec[1:cols(x_y_only)]    = ones(1,cols(x_y_only));
*/

x_y_vec              	    = zeros(1,cols(x_all));                                 /* ordered probit model */
x_y_vec[1:cols(x_joint)]    = ones(1,cols(x_joint));
x_y_vec[cols(x_joint)+1:cols(x_joint)+cols(x_y_only)]    = ones(1,cols(x_y_only));

/*
x_up_vec					= zeros(1,cols(x_all));                            	/* probit model for "ups" */
x_up_vec[cols(x_y_only)+1:cols(x_y_only)+cols(x_up_only)] = ones(1,cols(x_up_only));
*/

x_up_vec					= zeros(1,cols(x_all));                            	/* probit model for "ups" */
x_up_vec[1:cols(x_joint)]    = ones(1,cols(x_joint));
x_up_vec[cols(x_joint)+cols(x_y_only)+1:cols(x_joint)+cols(x_y_only)+cols(x_up_only)] = ones(1,cols(x_up_only));

x_down_vec = x_up_vec;															/* probit model for "ups" */

allvars = y_x_all_vars[4:rows(y_x_all_vars)];

x_up	= selif(x_all',x_up_vec')'; 
x_down  = selif(x_all',x_down_vec')'; 
x_y     = selif(x_all',x_y_vec')'; 

k_y  		= cols(x_y);
k_up_down	= cols(x_down);

			/* ENTER ordered, iop, iopc */

/* 
ordered	        - Ordered probit
IOP             - inflated OP
IOPC            - correlated inflated OP
TOP             - tempered OP
TOPC            - corelated tempered OP
note: set M > 1 to request panel versions in addition 
*/
                                            /* CURRENTLY ESTIMATES FULL MODEL: CHANGE IF REQUIRED! */
let model	= ordered;
let model   = IOP;
let model   = IOPC;
let model   = TOP;
let model   = TOPC;

/* ENTER NUMBER OF RANDOM DRAWS FOR RE VARIANTS: SET = 1 IF NO PANEL MODEL REQUIRED; OR M>1 FOR NUMBER OF HALTON DRAWS */

M = 100;

/* SET DEFAULT TOLERANCE LEVELS -1 MEANS TAKE CML DEFAULTS: NOTE APPLIES TO ALL MODELS */

tol = -1;      @ set to -1 for CML defaults @

/* PRINT ITERATIONS? */

print_it = 1;

/* ENTER INDEX NUMBER FOR INFLATION EG INDEX=2 INFLATES THE MIDDLE CATEGORY FOR J=3 OUTCOMES */

index = 2;

/* ENTER START VALUES - OPTIONAL, SET TO 0 FOR DEFAULT START VALUES */

let start_OP    = 
0.3941
0.2006
0.0892
0.0528
0.1066
0.0999
0.0643
0.3446
0.2674
-0.157
0.3227
0.0313
-0.0858
-0.1301
-0.1734
0.0432
0.4723
-0.2644
-0.0916
-0.1393
-0.1591
-0.1067
-0.2586
-0.1273
0.0496
-0.1178
-0.0242
0.017
0.0963
0.1389
0.1671
0.1658
0.2673
0.2136
0.2329
0.1879
0.1968
0.2665
0.2352
0.2388
0.1919
0.2088
-0.1095
0.2944
-0.159
0.239
-0.1591
0.0219
-0.0895
-1.3254
0.6654;

let start_IOP   = 
0.3184
0.2197
0.1303
0.0249
0.0896
0.1082
0.1007
0.3891
0.2789
-0.1962
0.3692
0.0458
-0.1092
-0.1691
-0.1844
0.069
0.5338
-0.2989
-0.0781
-0.1499
-0.1711
-0.1481
-0.3227
-0.203
0.0589
-0.1705
-0.0202
0.0265
0.1101
0.1603
0.2037
0.2123
0.3357
0.2831
0.3252
0.2732
0.293
0.3993
0.3703
0.3827
0.3189
0.3578
-0.1071
0.3348
-0.1956
0.2999
-0.1511
0.0637
-0.1641
-1.1264
0.2598
0.6922
0.205
0.0295
0.2171
0.3567
0.2383
0.0642
0.2156
-0.0727
-0.0138
-0.0274
0.0448
0.0078
0.1312
0.0539
-0.127
-0.0222
0.2521;

let start_IOP_RE = 
0.24378
0.12108
0.0863
0.03607
0.20256
0.13138
0.18437
0.34899
0.37616
-0.13019
0.34716
0.10064
-0.15416
-0.21333
-0.20777
0.09443
0.53224
-0.19793
0.01284
-0.10226
-0.23006
-0.24744
-0.39057
-0.49515
0.07226
-0.30405
-0.0846
0.08923
0.19113
0.26297
0.31969
0.33893
0.47478
0.38478
0.44288
0.35698
0.3917
0.50223
0.46463
0.47907
0.37293
0.42858
-0.2029
0.40915
-0.31611
0.46207
-0.25955
0.20184
-0.4241
-1.53197
-0.0523
0.50668
0.1837
0.02467
0.19316
0.26693
0.19874
0.01641
-0.10306
-0.05144
-0.03171
-0.0198
0.04742
0.01396
0.13131
0.05921
-0.16848
-0.00655
0.07919
0.60365
0.08353
0.70061
;

let start_IOPC = 
0.1026
0.1009
0.0757
-0.0415
-0.0923
-0.0408
0.0452
0.3349
0.228
-0.1632
0.3218
0.0345
-0.0826
-0.1308
-0.1667
0.0282
0.4353
-0.2362
-0.0665
-0.1259
-0.1657
-0.1405
-0.2473
-0.1649
0.048
-0.1258
-0.016
0.041
0.1136
0.1733
0.2228
0.2383
0.3513
0.3155
0.361
0.3331
0.3619
0.4601
0.4537
0.4695
0.4463
0.4832
0.1681
0.2771
-0.1318
0.2601
-0.0995
0.0431
-0.1178
-1.4355
0.1191
0.5325
0.1757
0.0304
0.1577
0.3342
0.2357
0.0462
0.3036
-0.0604
0.0015
-0.0269
0.0384
-0.0131
0.0969
0.04
0.0524
-0.0037
0.1411
-1.1958;

let start_IOPC_RE = 
0.04749
0.02564
0.05277
-0.03019
0.02941
-0.01521
0.12323
0.30098
0.31642
-0.11354
0.3027
0.07658
-0.11588
-0.18498
-0.185
0.05744
0.46638
-0.15706
-0.00208
-0.09829
-0.21516
-0.20695
-0.32418
-0.38838
0.06072
-0.24468
-0.05552
0.08381
0.17363
0.24617
0.30652
0.33524
0.4622
0.38919
0.43759
0.38543
0.41888
0.532
0.50978
0.52217
0.45385
0.51688
0.01845
0.33764
-0.25027
0.34878
-0.21255
0.16947
-0.36588
-2.01525
-0.09462
0.48797
0.17398
0.01509
0.18437
0.28557
0.24852
0.01466
-0.0093
-0.05353
-0.0106
-0.02961
0.05115
-0.00097
0.12795
0.05759
-0.04203
-0.00338
0.05293
-0.99678
0.5533
-0.27975
0.64401
;

let start_TOP       =  
0.1704
-0.0573
-0.1056
0.1587
-0.0853
-0.0564
-0.1548
0.3774
0.2791
-0.2003
0.3516
0.0459
-0.0923
-0.1535
-0.1684
0.0639
0.5096
-0.2854
-0.0671
-0.1316
-0.214
-0.1601
-0.3172
-0.2353
0.0561
-0.1371
-0.0237
0.0297
0.1139
0.1576
0.2043
0.2063
0.3364
0.2927
0.3316
0.2865
0.3136
0.4233
0.3916
0.417
0.3656
0.4139
-0.0579
0.3186
-0.1982
0.26
-0.1742
0.0573
-0.1407
-1.4202
0.2394
0.927
0.6902
0.3895
-0.0366
0.585
0.4264
0.4179
-0.0913
-0.0955
0.0086
-0.0692
0.1051
-0.0477
0.197
0.0867
0.2588
0.042
0.2717
0.3692
-0.4709
-0.4862
0.5956
0.0168
-0.0871
-0.4512
0.7836
-0.0535
-0.0697
0.0426
-0.0226
0.1064
0.0418
0.0494
-0.6931
-0.1498
0.1555;

let start_TOP_RE         =    
0.09975
-0.02518
0.2696
0.02401
-0.11223
-0.17605
-0.23512
0.30459
0.30705
-0.24965
0.29444
0.09292
-0.1092
-0.23903
-0.19937
0.08195
0.49115
-0.15826
0.01483
-0.06644
-0.25149
-0.28444
-0.39047
-0.41933
0.07485
-0.34382
-0.07004
0.12261
0.212
0.33017
0.41378
0.4542
0.57915
0.54782
0.61053
0.55897
0.59494
0.75415
0.70893
0.75564
0.66005
0.71293
0.02402
0.35774
-0.33701
0.31415
-0.25259
0.26886
-0.56108
-1.91604
-0.51197
0.7166
0.35433
-0.08749
0.21268
0.55297
0.51163
0.3839
-0.3447
-0.09849
0.00477
-0.04909
0.09162
-0.03488
0.19006
0.08842
0.12204
0.0202
0.06927
0.24482
-0.09258
0.52701
0.25904
-0.17444
-0.20555
-0.74126
0.6875
-0.00696
-0.06913
0.06423
-0.01485
0.03454
-0.04357
-0.0333
-0.87483
-0.10219
0.19228
0.79094
-0.48321
0.9163
0.97001
-0.44108
0.89047
;

let start_TOPC   = 
0.25954
-0.06988
-0.1973
0.09632
-0.1038
-0.14289
0.00544
0.33785
0.23478
-0.17374
0.3286
0.04091
-0.07602
-0.12261
-0.15376
0.04057
0.43811
-0.22808
-0.05177
-0.11646
-0.16824
-0.14551
-0.25215
-0.18841
0.04722
-0.1135
-0.02885
0.03754
0.1157
0.16419
0.20377
0.21195
0.31996
0.27843
0.31737
0.27882
0.29913
0.39
0.36964
0.38257
0.35015
0.38146
0.0307
0.27346
-0.14918
0.23273
-0.11046
0.03587
-0.14656
-1.31458
0.0095
0.33844
0.43666
0.39218
0.01089
0.44262
0.44514
0.10593
0.28351
-0.06448
0.00363
-0.0388
0.05043
-0.02814
0.12335
0.0455
0.14205
0.02809
0.14712
3.4605
-0.44804
-0.65691
0.39671
-0.01589
-0.27749
-0.1022
1.46011
-0.04199
-0.05416
0.02227
-0.00553
0.09002
0.03377
0.03825
-0.49407
-0.17065
0.19349
0.62024
-0.91989
;

let start_TOPC_RE =
0.42713
0.10213
0.02424
0.04334
0.10575
-0.16305
-0.0571
0.23355
0.24731
-0.19331
0.24478
0.08001
-0.08761
-0.1877
-0.16554
0.0403
0.41152
-0.13312
0.0094
-0.05265
-0.19131
-0.21387
-0.29451
-0.27105
0.05515
-0.26242
-0.03248
0.08243
0.16819
0.25334
0.30076
0.32715
0.43406
0.41839
0.45967
0.42544
0.4562
0.5862
0.54908
0.58587
0.5242
0.5806
0.0406
0.27576
-0.27279
0.266
-0.15768
0.19843
-0.38076
-0.92388
-0.26271
0.47939
0.51176
0.21891
0.38992
0.78636
1.29753
0.55922
0.66101
-0.22982
0.08015
-0.10031
0.15605
-0.09723
0.33207
0.15389
0.17832
0.05607
-0.01102
0.68944
0.15522
0.00938
0.14073
0.20728
-0.17138
-0.19554
0.3233
0.0042
-0.04561
0.02567
-0.0074
0.03013
0.01509
0.00499
-0.51475
-0.05438
0.1448
1.06119
0.70124
0.73969
-0.86643
1.51274
0.79584
-0.17978
0.57729
;

	{OP, V_OP, logl_OP, AIC_OP, BIC_OP, CAIC_OP, p_OP, p_OP_i, ret_OP,                                      
        me_OP, me_OP_se,                                                                            
    IOP, V_IOP, logl_IOP, AIC_IOP, BIC_IOP, CAIC_IOP, p_IOP, p_IOP_i, p_IOP_inf, p_IOP_purged, IOP_inf,
        p_IOP_components, p_IOP_components_i,    
        ret_IOP, me_IOP, me_IOP_se, me_IOP_inf, me_IOP_p_inf,                                                            
        LM_test,    
    IOP_RE, V_IOP_RE, logl_IOP_RE, AIC_IOP_RE, BIC_IOP_RE, CAIC_IOP_RE, p_IOP_RE, p_IOP_RE_i, p_IOP_RE_inf, p_IOP_RE_purged, IOP_RE_inf, 
        p_IOP_RE_components, p_IOP_RE_components_i, 
        ret_IOP_RE, me_IOP_RE, me_IOP_RE_se, me_IOP_RE_inf, me_IOP_RE_p_inf,
        LR_IOP_RE,
    IOPC, V_IOPC, logl_IOPC, AIC_IOPC, BIC_IOPC, CAIC_IOPC, p_IOPC, p_IOPC_i, p_IOPC_inf, p_IOPC_purged, IOPC_inf, 
        p_IOPC_components, p_IOPC_components_i,
        ret_IOPC, me_IOPC, me_IOPC_se, me_IOPC_inf, me_IOPC_p_inf, 
    IOPC_RE, V_IOPC_RE, logl_IOPC_RE, AIC_IOPC_RE, BIC_IOPC_RE, CAIC_IOPC_RE, p_IOPC_RE, p_IOPC_RE_i, p_IOPC_RE_inf, p_IOPC_RE_purged, IOPC_RE_inf, 
        p_IOPC_RE_components, p_IOPC_RE_components_i, 
        ret_IOPC_RE, me_IOPC_RE, me_IOPC_RE_se, me_IOPC_RE_inf, me_IOPC_RE_p_inf,
        LR_IOPC_RE,
    TOP, V_TOP, logl_TOP, AIC_TOP, BIC_TOP, CAIC_TOP, p_TOP, p_TOP_i, p_TOP_up, p_TOP_down, p_TOP_purged, TOP_inf,   
        p_TOP_components, p_TOP_components_i,
        ret_TOP, me_TOP, me_TOP_se, me_TOP_inf, me_TOP_p_inf, me_TOP_p_inf_se,
        LM_TOPC_vs_TOP, LR_test,
    TOP_RE, V_TOP_RE, logl_TOP_RE, AIC_TOP_RE, BIC_TOP_RE, CAIC_TOP_RE, p_TOP_RE, p_TOP_RE_i, p_TOP_RE_up, p_TOP_RE_down, p_TOP_RE_purged, TOP_RE_inf, 
        p_TOP_RE_components, p_TOP_RE_components_i,
        ret_TOP_RE, me_TOP_RE, me_TOP_RE_se, me_TOP_RE_inf, me_TOP_RE_p_inf, me_TOP_RE_p_inf_se,
        LR_TOP_RE,
    TOPC, V_TOPC, logl_TOPC, AIC_TOPC, BIC_TOPC, CAIC_TOPC, p_TOPC, p_TOPC_i, p_TOPC_up, p_TOPC_down, p_TOPC_purged, TOPC_inf,   
        p_TOPC_components, p_TOPC_components_i,
        ret_TOPC, me_TOPC, me_TOPC_se, me_TOPC_inf, me_TOPC_p_inf, me_TOPC_p_inf_se,
        LR_corr_vs_non, LM_corr_vs_corr, LM_corr_vs_IOP, LR_corr_vs_corr, LR_corr_vs_IOP, 
    TOPC_RE, V_TOPC_RE, logl_TOPC_RE, AIC_TOPC_RE, BIC_TOPC_RE, CAIC_TOPC_RE, p_TOPC_RE, p_TOPC_RE_i, p_TOPC_RE_up, p_TOPC_RE_down, p_TOPC_RE_purged, TOPC_RE_inf, 
        p_TOPC_RE_components, p_TOPC_RE_components_i,
        ret_TOPC_RE, me_TOPC_RE, me_TOPC_RE_se, me_TOPC_RE_inf, me_TOPC_RE_p_inf, me_TOPC_RE_p_inf_se,
        LR_TOPC_RE, LR_corr_vs_non_RE,
    y_star_OP, y_star_IOP, y_star_IOP_RE, y_star_IOPC, y_star_IOPC_RE, y_star_TOP, y_star_TOP_RE, y_star_TOPC, y_star_TOPC_RE}
        
		= IOP_TOP("FE_dat_shock",model,start_OP,start_IOP,start_IOP_RE,start_IOPC,start_IOPC_RE,start_TOP,start_TOP_RE,start_TOPC,start_TOPC_RE,
                        x_up_vec,x_down_vec,x_y_vec,tol,print_it);

/* PRINT RESULTS */

x_y_vars		= selif(x_all_vars,x_y_vec');
x_up_vars      	= selif(x_all_vars,x_up_vec');
x_down_vars    	= selif(x_all_vars,x_down_vec');

mu	    = "mu";
OP_vars	= x_y_vars $|(mu .*. ones(capJ-1,1));
se      = "s.e.";

let mtype = ordered IOP IOPC TOP TOPC;
mtype = indcv(model,mtype); 


/* SAVE ESTIMATION DATA PLUS LATENT INDICES */

y_stars = y_star_OP;
star_names = "y_st_OP";

if mtype ge 2;
    
    y_stars     = y_stars~y_star_IOP;
    namesplus   = "y_st_IOP" $| "inf_IOP";      
    star_names  = star_names $|namesplus;
    
    if M gt 1;
        
        y_stars     = y_stars~y_star_IOP_RE;
        namesplus   = "y_st_IOP_RE" $| "inf_IOP_RE";
        star_names  = star_names $| namesplus;
        
    endif;

    if mtype eq 3 or mtype eq 5;

        y_stars     = y_stars~y_star_IOPC;
        namesplus   = "y_st_IOPC" $| "inf_IOPC";
        star_names  = star_names $| namesplus;

        if M gt 1;
        
            y_stars     = y_stars~y_star_IOPC_RE;
            namesplus   = "y_st_IOPC_RE" $| "inf_IOPC_RE";
            star_names  = star_names $| namesplus;
        
        endif;
        
        if mtype ge 4;
            
            y_stars     = y_stars~y_star_TOP;
            namesplus   = "y_st_TOP" $| "up_TOP" $| "down_TOP";
            star_names  = star_names $| namesplus;
            
            if M gt 1;
        
                y_stars     = y_stars~y_star_TOP_RE;
                namesplus   = "y_st_TOP_RE" $| "up_TOP_RE" $| "down_TOP_RE";
                star_names  = star_names $| namesplus;
        
            endif;
            
            if mtype ge 5;
            
                y_stars     = y_stars~y_star_TOPC;
                namesplus   = "y_st_TOPC" $| "up_TOPC" $| "down_TOPC";
                star_names  = star_names $| namesplus;
            
                if M gt 1;
        
                    y_stars     = y_stars~y_star_TOPC_RE;
                    namesplus   = "y_st_TOPC_RE" $| "up_TOPC_RE" $| "down_TOPC_RE";
                    star_names  = star_names $| namesplus;
        
                endif;
            
            endif;
            
        endif;
        
    endif;

endif;


TOP_component_vars = "p_Down" $| "p_DownTemp" $| "p_NoChange" $| "p_UpTemp" $| "p_Up";

if mtype eq 5 and M gt 1;
    
    y_x_all_vars    = "PID" $| y_x_all_vars $| star_names $| TOP_component_vars;
    data            = pid~data~y_stars~p_TOPC_RE_components_i;
    // Create dataset with: 3 columns, 8 byte data and 1=numeric columns
    fh = datacreate(fname, y_x_all_vars, cols(data), 8, 1);
    call writer(fh, data);
    call close(fh);
    
endif;
                        /* CHANGE DIRECTORY/FILENAME AS APPROPRIATE BELOW */

output file = "U:\ManW10\Desktop\Mark code 21st June 2022\FE_LDV_JMCB_R1_latest.out" reset;
output on;

format 15,4;

?;
"               RANDOM EFFECTS INFLATED EXPECTATIONS MODELS";
?;
"FILE IS JMCB_gausscode_panel_hpc_withSVs.e";
?;
output file;
?;
"DATE IS";;datestring(0);
?;
"Note Model";;$model;
?;
"DSTATS";?;
dout        = dstatmt("FE_dat_shock", ".", dctl);
?;
"Time for program to run: ";;etstr(hsec-tStart);

if mtype ge 2;
    ?;"With j-0,...,J-1, inflation is on outcome";;index-1;?;
endif;

if M > 1;
    ?;"Number of Halton Draws for simulated models";;M;
endif;

?;"***Various Speficiation Tests***";?;

"***LM Tests of Generalised IOP vs IOP (-999/0, test failed/not estimated)***";

?;"LM test for TOP vs IOP";
"           test            df's        p-value";
LM_test;

?;"LM test for TOPC vs IOPC";
"           test            df's        p-value";
LM_corr_vs_corr;

?;"LM test for TOPC vs IOP";
"           test            df's        p-value";
LM_corr_vs_IOP;
?; 

"***LM Tests of Correlated Generalised IOP vs Non-correlated (-999/0, test failed/not estimated)***";

?;"LM test for TOPC vs TOP";
"           test            df's        p-value";
LM_TOPC_vs_TOP;?;    

?;"*** LR Test of GTOPC vs GTOP ***";
"           test            df's        p-value";
LR_corr_vs_non;?;

?;"*** LR Test of Panel GTOPC vs GTOP ***";
"           test            df's        p-value";
LR_corr_vs_non_RE;?;

"***LR Tests of RE Variants vs Pooled (-999/0, test failed/not estimated)***";

?;"LR Test RE IOP vs pooled";
"           test            df's        p-value";
LR_IOP_RE;

?;"LR Test RE IOPC vs pooled IOPC";
"           test            df's        p-value";
LR_IOPC_RE;

?;"LR Test RE TOP vs pooled";
"           test            df's        p-value";
LR_TOP_RE;

?;"LR Test RE TOPC vs pooled";
"           test            df's        p-value";
LR_TOPC_RE;

print;
print;
"ORDERED PROBIT";
print;
"Convergence codF:";;$ret_OP;
print;
format 10,8;
"Max L";;logl_OP;
print;
" AIC       BIC         CAIC";
print;
AIC_OP~BIC_OP~CAIC_OP;
print;

/* HIT/MISS TABLE */
{HM_OP,correct} = hitmiss(p_OP_i,y);
"% Correct           ";;correct[1];
"Corrected Prediction  ";;correct[2];
"(close to 0 = no prediction)";?;

format 15,4;
print;
"ESTIMATED PARAMETERS";
print;

for i (1,rows(OP),1);
	$OP_vars[i];;OP[i,.];
endfor;
print;

"MARGINAL EFFECTS AND STANDARD ERRORS";
print;
for i (1,kx_y,1);
	$x_y_vars[i];;me_OP[i,.];
    $se;;me_OP_se[i,.];
endfor;
print;

if mtype ge 2;
    
    print;
    print;
    "INFLATED ORDERED PROBIT MODEL";
    print;
    "Convergence codF:";;$ret_IOP;
    print;
    format 10,8;
    "Max L";;logl_IOP;
    print;
    " AIC       BIC         CAIC";
    print;
    AIC_IOP~BIC_IOP~CAIC_IOP;  
    print;
    
    /* HIT/MISS TABLE */
    {HM_IOP,correct} = hitmiss(p_IOP_i,y);?;
    ?;"% Correct           ";;correct[1];
    "Corrected Prediction  ";;correct[2];
    "(close to 0 = no prediction)";?;
    
    format 15,4;

    "Summary Probabilities";
    prob_labels = "Down" $| "No-Change" $| "Up"; 	
    sprintf("%10s   %10s     %10s       %10s", "Outcome", "Proportions", "Probs (se)", "Purged (se)");
    sprintf("%10s  %10.4f %10.4f (%4.4f) %10.4f (%4.4f)", prob_labels, phat, p_IOP[.,1], p_IOP[.,2], p_IOP_purged[.,1], p_IOP_purged[.,2]);
    ?;

    IOP_component_vars = "p_down" $| "p_inflated" $| "p_no-change" $| "p_up";   
    "Component probabilities";    
    sprintf("%12s  %8s %8s", "Component", "Prob.", "se(ind.)");
    sprintf("%12s  %8.4f (%4.4f)", IOP_component_vars, p_IOP_components[.,1], p_IOP_components[.,2]);
    ?;

    "Inflation amount, with standard error";
    IOP_inf;
    ?;

	"Marginal Tempering Probability, with standard error";
	print;
	p_IOP_inf;
	print;
            
    "Estimated '2nd Stage' Ordered Parameters";
    print;
    for i (1,rows(OP),1);
	    $OP_vars[i];;IOP[i,.];
    endfor;
    print; 

    print;
    "Estimated Tempering Function Parameters";
    print;
    for i (1,rows(x_up_vars),1);
	    $x_up_vars[i];;IOP[rows(OP)+i,.];
    endfor;
    print;
    
    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
    for i (1,rows(x_all_vars),1);
        $x_all_vars[i];;me_IOP[i,.];
        $se;;me_IOP_se[i,.];
    endfor;
    print;

    "MARGINAL EFFECTS OF INFLATION AMOUNT AND STANDARD ERRORS";
    print;
    for i (1,rows(x_all_vars),1);
        $x_all_vars[i];;me_IOP_inf[i,.];
    endfor;
    print;

    "MARGINAL EFFECTS OF INFLATION PROBABILITY AND STANDARD ERRORS";
    print;
    for i (1,rows(x_all_vars),1);
        $x_all_vars[i];;me_IOP_p_inf[i,.];
    endfor;
    print;
    
    if M gt 1;
        
        print;
        print;
        "PANEL INFLATED ORDERED PROBIT MODEL";
        print;
        "Convergence code:";;$ret_IOP_RE;
        print;
        format 10,8;
        "Max L";;logl_IOP_RE;
        print;
        " AIC       BIC         CAIC";
        print;
        AIC_IOP_RE~BIC_IOP_RE~CAIC_IOP_RE;  
        print;
        
        /* HIT/MISS TABLE */
        {HM_IOP_RE,correct} = hitmiss(p_IOP_RE_i,y);?;
        ?;"% Correct           ";;correct[1];
        "Corrected Prediction  ";;correct[2];
        "(close to 0 = no prediction)";?;

        format 15,4;

        "Summary Probabilities";
        sprintf("%10s   %10s     %10s       %10s", "Outcome", "Proportions", "Probs (se)", "Purged (se)");
        sprintf("%10s  %10.4f %10.4f (%4.4f) %10.4f (%4.4f)", prob_labels, phat, p_IOP_RE[.,1], p_IOP_RE[.,2], p_IOP_RE_purged[.,1], p_IOP_RE_purged[.,2]);
        ?;

        "Component probabilities";    
        sprintf("%12s  %8s %8s", "Component", "Prob.", "se(ind.)");
        sprintf("%12s  %8.4f (%4.4f)", IOP_component_vars, p_IOP_RE_components[.,1], p_IOP_RE_components[.,2]);
        ?;

        "Inflation amount, with standard error";
        ?;
        IOP_RE_inf;
        ?;

        "Marginal Tempering Probability, with standard error";
        print;
        p_IOP_RE_inf;
        print;
    
        "Estimated '2nd Stage' Ordered Parameters";
        print;
        for i (1,rows(OP),1);
            $OP_vars[i];;IOP_RE[i,.];
        endfor;
        print; 

        print;
        "Estimated Tempering/Inflation Function Parameters";
        print;
        for i (1,rows(x_up_vars),1);
            $x_up_vars[i];;IOP_RE[rows(OP)+i,.];
        endfor;
        print;
    
        print;
        "Panel RE Parameters";
        print;
        "V(output)      ";;IOP_RE[kx_y+capJ-1+kx_up+1,.];
        "Cov(output,inf)";;IOP_RE[kx_y+capJ-1+kx_up+2,.];
        "V(inflation)   ";;IOP_RE[kx_y+capJ-1+kx_up+3,.];
        print;
                
        "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
        print;
        for i (1,rows(x_all_vars),1);
            $x_all_vars[i];;me_IOP_RE[i,.];
            $se;;me_IOP_RE_se[i,.];
        endfor;
        print;

        "MARGINAL EFFECTS OF INFLATION AMOUNT AND STANDARD ERRORS";
        print;
        for i (1,rows(x_all_vars),1);
            $x_all_vars[i];;me_IOP_RE_inf[i,.];
        endfor;
        print;

        "MARGINAL EFFECTS OF INFLATION PROBABILITY AND STANDARD ERRORS";
        print;
        for i (1,rows(x_all_vars),1);
            $x_all_vars[i];;me_IOP_RE_p_inf[i,.];
        endfor;
        print;        
        
    endif;  
    
endif;

if mtype eq 3 or mtype eq 5;
    
    print;
    print;
    "CORRELATED INFLATED ORDERED PROBIT MODEL";
    print;
    "Convergence codF:";;$ret_IOPC;
    print;
    format 10,8;
    "Max L";;logl_IOPC;
    print;
    " AIC       BIC         CAIC";
    print;
    AIC_IOPC~BIC_IOPC~CAIC_IOPC;  
    print;
    
    /* HIT/MISS TABLE */
    {HM_IOPC,correct} = hitmiss(p_IOPC_i,y);?;
    ?;"% Correct           ";;correct[1];
    "Corrected Prediction  ";;correct[2];
    "(close to 0 = no prediction)";?;

    format 15,4;

    "Summary Probabilities";
    sprintf("%10s   %10s     %10s       %10s", "Outcome", "Proportions", "Probs (se)", "Purged (se)");
    sprintf("%10s  %10.4f %10.4f (%4.4f) %10.4f (%4.4f)", prob_labels, phat, p_IOPC[.,1], p_IOPC[.,2], p_IOPC_purged[.,1], p_IOPC_purged[.,2]);
    ?;

    "Component probabilities";    
    sprintf("%12s  %8s %8s", "Component", "Prob.", "se(ind.)");
    sprintf("%12s  %8.4f (%4.4f)", IOP_component_vars, p_IOPC_components[.,1], p_IOPC_components[.,2]);
    ?;

    "Inflation amount, with standard error";
    ?;
    IOPC_inf;
    ?;

	"Marginal Tempering Probability, with standard error";
	print;
	p_IOPC_inf;
	print;
    
    "Estimated '2nd Stage' Ordered Parameters";
    print;
    for i (1,rows(OP),1);
	    $OP_vars[i];;IOPC[i,.];
    endfor;
    print; 

    print;
    "Estimated Tempering Function Parameters";
    print;
    for i (1,rows(x_up_vars),1);
	    $x_up_vars[i];;IOPC[rows(OP)+i,.];
    endfor;
    print;
    
    "       rho";;IOPC[rows(IOPC),.];
    print;
    
    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
    for i (1,rows(x_all_vars),1);
        $x_all_vars[i];;me_IOPC[i,.];
        $se;;me_IOPC_se[i,.];
    endfor;
    print;

    "MARGINAL EFFECTS OF INFLATION AMOUNT AND STANDARD ERRORS";
    print;
    for i (1,rows(x_all_vars),1);
        $x_all_vars[i];;me_IOPC_inf[i,.];
    endfor;
    print;

    "MARGINAL EFFECTS OF INFLATION PROBABILITY AND STANDARD ERRORS";
    print;
    for i (1,rows(x_all_vars),1);
        $x_all_vars[i];;me_IOPC_p_inf[i,.];
    endfor;
    print;
    
    if M gt 1;

        print;
        print;
        "PANEL CORRELATED INFLATED ORDERED PROBIT MODEL";
        print;
        "Convergence codF:";;$ret_IOPC_RE;
        print;
        format 10,8;
        "Max L";;logl_IOPC_RE;
        print;
        " AIC       BIC         CAIC";
        print;
        AIC_IOPC_RE~BIC_IOPC_RE~CAIC_IOPC_RE;  
        print;
        
        /* HIT/MISS TABLE */
        {HM_IOPC_RE,correct} = hitmiss(p_IOPC_RE_i,y);?;
        ?;"% Correct           ";;correct[1];
        "Corrected Prediction  ";;correct[2];
        "(close to 0 = no prediction)";?;

        format 15,4;

        "Summary Probabilities";
        sprintf("%10s   %10s     %10s       %10s", "Outcome", "Proportions", "Probs (se)", "Purged (se)");
        sprintf("%10s  %10.4f %10.4f (%4.4f) %10.4f (%4.4f)", prob_labels, phat, p_IOPC_RE[.,1], p_IOPC_RE[.,2], p_IOPC_RE_purged[.,1], p_IOPC_RE_purged[.,2]);
        ?;

        "Component probabilities";    
        sprintf("%12s  %8s %8s", "Component", "Prob.", "se(ind.)");
        sprintf("%12s  %8.4f (%4.4f)", IOP_component_vars, p_IOPC_RE_components[.,1], p_IOPC_RE_components[.,2]);
        ?;

        "Inflation amount, with standard error";
        ?;
        IOPC_RE_inf;
        ?;

        "Marginal Tempering Probability, with standard error";
        print;
        p_IOPC_RE_inf;
        print;
    
        "Estimated '2nd Stage' Ordered Parameters";
        print;
        for i (1,rows(OP),1);
            $OP_vars[i];;IOPC_RE[i,.];
        endfor;
        print; 

        print;
        "Estimated Tempering/Inflation Function Parameters";
        print;
        for i (1,rows(x_up_vars),1);
            $x_up_vars[i];;IOPC_RE[rows(OP)+i,.];
        endfor;
        print;
    
        "       rho";;IOPC_RE[kx_y+capJ-1+kx_up+1,.];
        print;
        
        print;
        "Panel RE Parameters";
        print;
        "V(output)      ";;IOPC_RE[kx_y+capJ-1+kx_up+2,.];
        "Cov(output,inf)";;IOPC_RE[kx_y+capJ-1+kx_up+3,.];
        "V(inflation)   ";;IOPC_RE[kx_y+capJ-1+kx_up+4,.];
        print;
        
        "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
        print;
        for i (1,rows(x_all_vars),1);
            $x_all_vars[i];;me_IOPC_RE[i,.];
            $se;;me_IOPC_RE_se[i,.];
        endfor;
        print;

        "MARGINAL EFFECTS OF INFLATION AMOUNT AND STANDARD ERRORS";
        print;
        for i (1,rows(x_all_vars),1);
            $x_all_vars[i];;me_IOPC_RE_inf[i,.];
        endfor;
        print;

        "MARGINAL EFFECTS OF INFLATION PROBABILITY AND STANDARD ERRORS";
        print;
        for i (1,rows(x_all_vars),1);
            $x_all_vars[i];;me_IOPC_RE_p_inf[i,.];
        endfor;
        print;        
        
    endif;
    
endif;


if mtype ge 4;
    
    print;
    print;
    "GENERALISED INFLATED ORDERED PROBIT MODEL";
    print;
    "Convergence codF:";;$ret_TOP;
    print;
    format 10,8;
    "Max L";;logl_TOP;
    print;
    " AIC       BIC         CAIC";
    print;
    AIC_TOP~BIC_TOP~CAIC_TOP;  
    print;
    
    "HIT/MISS TABLE";?;
    {HM_TOP,correct} = hitmiss(p_TOP_i,y);?;
    ?;"% Correct           ";;correct[1];
    "Corrected Prediction  ";;correct[2];
    "(close to 0 = no prediction)";?;
    
    format 15,4;

	"	Sample      	 Average
	Proportions 	 Probs         SE(prob)          Purged       SE(purged) 	";
	phat~p_TOP~p_TOP_purged;
	print;

    "Summary Probabilities";
    sprintf("%10s   %10s     %10s       %10s", "Outcome", "Proportions", "Probs (se)", "Purged (se)");
    sprintf("%10s  %10.4f %10.4f (%4.4f) %10.4f (%4.4f)", prob_labels, phat, p_TOP[.,1], p_TOP[.,2], p_TOP_purged[.,1], p_TOP_purged[.,2]);
    ?;

    "Component probabilities";    
    sprintf("%12s  %8s %8s", "Component", "Prob.", "se(ind.)");
    sprintf("%12s  %8.4f (%4.4f)", TOP_component_vars, p_TOP_components[.,1], p_TOP_components[.,2]);
    ?;

    "Inflation amount, with standard error";
    ?;TOP_inf;?;

	"Marginal Tempering Probability from UP, with standard error";
	print;
	p_TOP_up;
	print;
    
	"Marginal Tempering Probability from DOWN, with standard error";
	print;
	p_TOP_down;
	print;
    
    "Estimated '1st Stage' Ordered Parameters";
    print;
    for i (1,rows(OP),1);
	    $OP_vars[i];;TOP[i,.];
    endfor;
    print; 

    print;
    "Estimated Tempering *UP* Function Parameters";
    print;
    for i (1,rows(x_up_vars),1);
	    $x_up_vars[i];;TOP[rows(OP)+i,.];
    endfor;
    print;

    print;
    "Estimated *DOWN* Function Parameters";
    print;
    for i (1,rows(x_down_vars),1);
	    $x_down_vars[i];;TOP[rows(OP)+rows(x_up_vars)+i,.];
    endfor;
    print;
        
    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
    for i (1,rows(x_all_vars),1);
        $x_all_vars[i];;me_TOP[i,.];
        $se;;me_TOP_se[i,.];
    endfor;
    print;

    "MARGINAL EFFECTS OF INFLATION AMOUNT AND STANDARD ERRORS";
    print;
    for i (1,rows(x_all_vars),1);
        $x_all_vars[i];;me_TOP_inf[i,.];
    endfor;
    print;

    "MARGINAL EFFECTS OF THE PROBABILITY OF INFLATION AND STANDARD ERRORS; jor j=1,...,J; Final column is the average";
    print;
    for i (1,rows(x_all_vars),1);
        $x_all_vars[i];;me_TOP_p_inf[i,.];
        $se;;me_TOP_p_inf_se[i,.];
    endfor;
    print;    
       
    if M gt 1;
        
        print;
        print;
        " PANEL GENERALISED INFLATED ORDERED PROBIT MODEL";
        print;
        "Convergence codF:";;$ret_TOP_RE;
        print;
        format 10,8;
        "Max L";;logl_TOP_RE;
        print;
        " AIC       BIC         CAIC";
        print;
        AIC_TOP_RE~BIC_TOP_RE~CAIC_TOP_RE;  
        print;
        
        "HIT/MISS TABLE";?;
        {HM_TOP_RE,correct} = hitmiss(p_TOP_RE_i,y);?;
        ?;"% Correct           ";;correct[1];
        "Corrected Prediction  ";;correct[2];
        "(close to 0 = no prediction)";?;

        format 15,4;

        "Summary Probabilities";
        sprintf("%10s   %10s     %10s       %10s", "Outcome", "Proportions", "Probs (se)", "Purged (se)");
        sprintf("%10s  %10.4f %10.4f (%4.4f) %10.4f (%4.4f)", prob_labels, phat, p_TOP_RE[.,1], p_TOP_RE[.,2], p_TOP_RE_purged[.,1], p_TOP_RE_purged[.,2]);
        ?;

        "Component probabilities";    
        sprintf("%12s  %8s %8s", "Component", "Prob.", "se(ind.)");
        sprintf("%12s  %8.4f (%4.4f)", TOP_component_vars, p_TOP_RE_components[.,1], p_TOP_RE_components[.,2]);
        ?;
        
        "Inflation amount, with standard error";
        ?;TOP_RE_inf;?;

        "Marginal Tempering Probability from UP, with standard error";
        print;
        p_TOP_RE_up;
        print;
    
        "Marginal Tempering Probability from DOWN, with standard error";
        print;
        p_TOP_RE_down;
        print;
        
        "Estimated '1st Stage' Ordered Parameters";
        print;
        for i (1,rows(OP),1);
            $OP_vars[i];;TOP_RE[i,.];
        endfor;
        print; 

        print;
        "Estimated Tempering *UP* Function Parameters";
        print;
        for i (1,rows(x_up_vars),1);
            $x_up_vars[i];;TOP_RE[rows(OP)+i,.];
        endfor;
        print;

        print;
        "Estimated *DOWN* Function Parameters";
        print;
        for i (1,rows(x_down_vars),1);
            $x_down_vars[i];;TOP_RE[rows(OP)+rows(x_up_vars)+i,.];
        endfor;
        print;
        
        print;
        "Panel RE Parameters";
        print;
        "V(output)       ";;TOP_RE[kx_y+capJ-1+kx_up+kx_down+1,.];
        "V(up)           ";;TOP_RE[kx_y+capJ-1+kx_up+kx_down+2,.];
        "V(down)         ";;TOP_RE[kx_y+capJ-1+kx_up+kx_down+3,.];
        "Cov(output,up)  ";;TOP_RE[kx_y+capJ-1+kx_up+kx_down+4,.];
        "Cov(output,down)";;TOP_RE[kx_y+capJ-1+kx_up+kx_down+5,.];
        "Cov(up,down)    ";;TOP_RE[kx_y+capJ-1+kx_up+kx_down+5,.];        
        print;        
        
        "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
        print;
        for i (1,rows(x_all_vars),1);
            $x_all_vars[i];;me_TOP_RE[i,.];
            $se;;me_TOP_RE_se[i,.];
        endfor;
        print;

        "MARGINAL EFFECTS OF INFLATION AMOUNT AND STANDARD ERRORS";
        print;
        for i (1,rows(x_all_vars),1);
            $x_all_vars[i];;me_TOP_RE_inf[i,.];
        endfor;
        print;

        "MARGINAL EFFECTS OF THE PROBABILITY OF INFLATION AND STANDARD ERRORS; jor j=1,...,J; Final column is the average";
        print;
        for i (1,rows(x_all_vars),1);
            $x_all_vars[i];;me_TOP_RE_p_inf[i,.];
            $se;;me_TOP_RE_p_inf_se[i,.];
        endfor;
        print;
        
    endif;
    
endif;


if mtype eq 5;
    
    print;
    print;
    "CORRELATED GENERALISED INFLATED ORDERED PROBIT MODEL";
    print;
    "Convergence code:";;$ret_TOPC;
    print;
    format 10,8;
    "Max L";;logl_TOPC;
    print;
    " AIC       BIC         CAIC";
    print;
    AIC_TOPC~BIC_TOPC~CAIC_TOPC;  
    print;
    
    "HIT/MISS TABLE";?;
    {HM_TOPC,correct} = hitmiss(p_TOPC_i,y);?;
    ?;"% Correct           ";;correct[1];
    "Corrected Prediction  ";;correct[2];
    "(close to 0 = no prediction)";?;

    format 15,4;

	"	Sample      	 Average
	Proportions 	 Probs         SE(prob)          Purged       SE(purged) 	";
	phat~p_TOPC~p_TOPC_purged;
	print;

    "Summary Probabilities";
    sprintf("%10s   %10s     %10s       %10s", "Outcome", "Proportions", "Probs (se)", "Purged (se)");
    sprintf("%10s  %10.4f %10.4f (%4.4f) %10.4f (%4.4f)", prob_labels, phat, p_TOPC[.,1], p_TOPC[.,2], p_TOPC_purged[.,1], p_TOPC_purged[.,2]);
    ?;

    "Component probabilities";    
    sprintf("%12s  %8s %8s", "Component", "Prob.", "se(ind.)");
    sprintf("%12s  %8.4f (%4.4f)", TOP_component_vars, p_TOPC_components[.,1], p_TOPC_components[.,2]);
    ?;

    "Inflation amount, with standard error";
    ?;TOPC_inf;?;

	"Marginal Tempering Probability from UP, with standard error";
	print;
	p_TOPC_up;
	print;
    
	"Marginal Tempering Probability from DOWN, with standard error";
	print;
	p_TOPC_down;
	print;
        
    "Estimated '1st Stage' Ordered Parameters";
    print;
    for i (1,rows(OP),1);
	    $OP_vars[i];;TOPC[i,.];
    endfor;
    print; 

    print;
    "Estimated Tempering *UP* Function Parameters";
    print;
    for i (1,rows(x_up_vars),1);
	    $x_up_vars[i];;TOPC[rows(OP)+i,.];
    endfor;
    print;

    print;
    "Estimated *DOWN* Function Parameters";
    print;
    for i (1,rows(x_down_vars),1);
	    $x_down_vars[i];;TOPC[rows(OP)+rows(x_up_vars)+i,.];
    endfor;
    print;
        
    print;
	"Correlation Parameters";
	print;
	"		Rho_1";;TOPC[kx_y+capJ-1+kx_up+kx_down+1,.];
	"		Rho_2";;TOPC[kx_y+capJ-1+kx_up+kx_down+2,.];	
	if capJ ge 4;	
		"		Rho_3";;TOPC[kx_y+capJ-1+kx_up+kx_down+3,.];
		if capJ ge 5;			
			"	  Rho_4";;TOPC[kx_y+capJ-1+kx_up+kx_down+4,.];
		endif;			
	endif;	
	?;
    
    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
    for i (1,rows(x_all_vars),1);
        $x_all_vars[i];;me_TOPC[i,.];
        $se;;me_TOPC_se[i,.];
    endfor;
    print;

    "MARGINAL EFFECTS OF INFLATION AMOUNT AND STANDARD ERRORS";
    print;
    for i (1,rows(x_all_vars),1);
        $x_all_vars[i];;me_TOPC_inf[i,.];
    endfor;
    print;

    "MARGINAL EFFECTS OF THE PROBABILITY OF INFLATION AND STANDARD ERRORS; jor j=1,...,J; Final column is the average";
    print;
    for i (1,rows(x_all_vars),1);
        $x_all_vars[i];;me_TOPC_p_inf[i,.];
        $se;;me_TOPC_p_inf_se[i,.];
    endfor;
    print;    

    if M gt 1;
    
        print;
        print;
        "PANEL CORRELATED GENERALISED INFLATED ORDERED PROBIT MODEL";
        print;
        "Convergence codF:";;$ret_TOPC_RE;
        print;
        format 10,8;
        "Max L";;logl_TOPC_RE;
        print;
        " AIC       BIC         CAIC";
        print;
        AIC_TOPC_RE~BIC_TOPC_RE~CAIC_TOPC_RE;  
        print;
        
        "HIT/MISS TABLE";?;
        {HM_TOPC_RE,correct} = hitmiss(p_TOPC_RE_i,y);?;
        ?;"% Correct           ";;correct[1];
        "Corrected Prediction  ";;correct[2];
        "(close to 0 = no prediction)";?;

        format 15,4;

        "Summary Probabilities";
        sprintf("%10s   %10s     %10s       %10s", "Outcome", "Proportions", "Probs (se)", "Purged (se)");
        sprintf("%10s  %10.4f %10.4f (%4.4f) %10.4f (%4.4f)", prob_labels, phat, p_TOPC_RE[.,1], p_TOPC_RE[.,2], p_TOPC_RE_purged[.,1], p_TOPC_RE_purged[.,2]);
        ?;

        "Component probabilities";    
        sprintf("%12s  %8s %8s", "Component", "Prob.", "se(ind.)");
        sprintf("%12s  %8.4f (%4.4f)", TOP_component_vars, p_TOPC_RE_components[.,1], p_TOPC_RE_components[.,2]);
        ?;

        "Inflation amount, with standard error";
        ?;TOPC_RE_inf;?;

        "Marginal Tempering Probability from UP, with standard error";
        print;
        p_TOPC_RE_up;
        print;
    
        "Marginal Tempering Probability from DOWN, with standard error";
        print;
        p_TOPC_RE_down;
        print;
        
        "Estimated '1st Stage' Ordered Parameters";
        print;
        for i (1,rows(OP),1);
            $OP_vars[i];;TOPC_RE[i,.];
        endfor;
        print; 

        print;
        "Estimated Tempering *UP* Function Parameters";
        print;
        for i (1,rows(x_up_vars),1);
            $x_up_vars[i];;TOPC_RE[rows(OP)+i,.];
        endfor;
        print;

        print;
        "Estimated *DOWN* Function Parameters";
        print;
        for i (1,rows(x_down_vars),1);
            $x_down_vars[i];;TOPC_RE[rows(OP)+rows(x_up_vars)+i,.];
        endfor;
        print;
        
        print;
        "Correlation Parameters";
        print;
        "		Rho_1";;TOPC_RE[kx_y+capJ-1+kx_up+kx_down+1,.];
        "		Rho_2";;TOPC_RE[kx_y+capJ-1+kx_up+kx_down+2,.];	
        if capJ ge 4;	
            "		Rho_3";;TOPC_RE[kx_y+capJ-1+kx_up+kx_down+3,.];
            if capJ ge 5;			
                "	  Rho_4";;TOPC_RE[kx_y+capJ-1+kx_up+kx_down+4,.];
            endif;			
        endif;	
        ?;

        if capJ eq 3;
            
            print;
            "Panel RE Parameters";
            print;
            "V(output)       ";;TOPC_RE[kx_y+capJ-1+kx_up+kx_down+3,.];
            "V(up)           ";;TOPC_RE[kx_y+capJ-1+kx_up+kx_down+4,.];
            "V(down)         ";;TOPC_RE[kx_y+capJ-1+kx_up+kx_down+5,.];
            "Cov(output,up)  ";;TOPC_RE[kx_y+capJ-1+kx_up+kx_down+6,.];
            "Cov(output,down)";;TOPC_RE[kx_y+capJ-1+kx_up+kx_down+7,.];
            "Cov(up,down)    ";;TOPC_RE[kx_y+capJ-1+kx_up+kx_down+8,.];        
            print;        
        
        endif;
            
        "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
        print;
        for i (1,rows(x_all_vars),1);
            $x_all_vars[i];;me_TOPC_RE[i,.];
            $se;;me_TOPC_RE_se[i,.];
        endfor;
        print;

        "MARGINAL EFFECTS OF INFLATION AMOUNT AND STANDARD ERRORS";
        print;
        for i (1,rows(x_all_vars),1);
            $x_all_vars[i];;me_TOPC_RE_inf[i,.];
        endfor;
        print;

        "MARGINAL EFFECTS OF THE PROBABILITY OF INFLATION AND STANDARD ERRORS; jor j=1,...,J; Final column is the average";
        print;
        for i (1,rows(x_all_vars),1);
            $x_all_vars[i];;me_TOPC_RE_p_inf[i,.];
            $se;;me_TOPC_RE_p_inf_se[i,.];
        endfor;
        print;
    
    endif;    
        
endif;

output off;
closeall;

stop;
